﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Menus;
using System.Collections.ObjectModel;

namespace ContextMenuNullException
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Items = new ObservableCollection<Item>()
            {
                new Item()
                {
                    HeaderText = "Item 1",
                    SubItems = new ObservableCollection<Item>()
                    {
                        new Item { HeaderText = "Sub 1.1" },
                        new Item { HeaderText = "Sub 1.2" }
                    }
                },
                new Item()
                {
                    HeaderText = "Item 2",
                    SubItems = new ObservableCollection<Item>()
                    {
                        new Item { HeaderText = "Sub 2.1" },
                        new Item { HeaderText = "Sub 2.2" }
                    }
                }
            };

            DataContext = this;
        }

        public ObservableCollection<Item> Items { get; set; }

        private void XamContextMenu_Loaded(object sender, RoutedEventArgs e)
        {
            (sender as XamContextMenu).ItemsSource = Items;
        }
    }

    public class Item
    {
        public string HeaderText { get; set; }
        public ObservableCollection<Item> SubItems { get; set; }
    }
}
